diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_nick.c ircd-hybrid-7-bg/modules/core/m_nick.c
--- ircd-hybrid-7rc5/modules/core/m_nick.c	Thu Oct  3 11:33:43 2002
+++ ircd-hybrid-7-bg/modules/core/m_nick.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_nick.c,v 1.97 2002/10/03 15:33:43 bill Exp $
+ *  $Id: m_nick.c,v 1.4 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -46,6 +46,7 @@
 #include "modules.h"
 #include "common.h"
 #include "packet.h"
+#include "s_misc.h"
 
 
 static void mr_nick(struct Client *, struct Client *, int, char**);
@@ -64,7 +65,7 @@
 static int check_clean_user(struct Client *, char *, char *, char *);
 static int check_clean_host(struct Client *, char *, char *, char *);
 
-static int clean_nick_name(char *);
+static int clean_nick_name(char *, int);
 static int clean_user_name(char *);
 static int clean_host_name(char *);
 
@@ -97,7 +98,7 @@
   mod_del_cmd(&client_msgtab);
 }
 
-const char *_version = "$Revision: 1.97 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 
 /*
@@ -117,7 +118,7 @@
    
   if(parc < 2 || BadPtr(parv[1]))
   {
-    sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+    sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                me.name, BadPtr(parv[0]) ? "*" : parv[0]);
     return;
   }
@@ -130,9 +131,9 @@
   strlcpy(nick, parv[1], NICKLEN);
 
   /* check the nickname is ok */
-  if(!clean_nick_name(nick))
+  if(!clean_nick_name(nick, 0))
   {
-    sendto_one(source_p, form_str(ERR_ERRONEUSNICKNAME),
+    sendto_one(source_p, form_str(source_p,ERR_ERRONEUSNICKNAME),
                me.name, BadPtr(parv[0]) ? "*" : parv[0], parv[1]);
     return;
   }
@@ -141,7 +142,7 @@
   if(find_nick_resv(nick) &&
      !(IsOper(source_p) && ConfigChannel.oper_pass_resv))
   {
-    sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+    sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
                me.name, BadPtr(parv[0]) ? "*" : parv[0], nick);
     return;
   }
@@ -161,7 +162,7 @@
 	  /* We're already waiting for a reply about this nick
 	   * for someone else. */
 
-	  sendto_one(source_p, form_str(ERR_NICKNAMEINUSE), me.name, "*", nick);
+	  sendto_one(source_p, form_str(source_p,ERR_NICKNAMEINUSE), me.name, "*", nick);
 	  return;
 	}
       }
@@ -189,7 +190,7 @@
   }
   else
   {
-    sendto_one(source_p, form_str(ERR_NICKNAMEINUSE), me.name, "*", nick);
+    sendto_one(source_p, form_str(source_p,ERR_NICKNAMEINUSE), me.name, "*", nick);
   }
 }
 
@@ -208,7 +209,7 @@
   /* XXX BadPtr is needed */
   if(parc < 2 || BadPtr(parv[1]))
   {
-    sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN),
+    sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN),
                me.name, parv[0]);
     return;
   }
@@ -221,9 +222,9 @@
   strlcpy(nick, parv[1], NICKLEN);
 
   /* check the nickname is ok */
-  if(!clean_nick_name(nick))
+  if(!clean_nick_name(nick, 0))
   {
-    sendto_one(source_p, form_str(ERR_ERRONEUSNICKNAME),
+    sendto_one(source_p, form_str(source_p,ERR_ERRONEUSNICKNAME),
                me.name, parv[0], nick);
     return;
   }
@@ -231,7 +232,7 @@
   if(find_nick_resv(nick) &&
      !(IsOper(source_p) && ConfigChannel.oper_pass_resv))
   {
-    sendto_one(source_p, form_str(ERR_UNAVAILRESOURCE),
+    sendto_one(source_p, form_str(source_p,ERR_UNAVAILRESOURCE),
                me.name, parv[0], nick);
     return;
   }
@@ -274,7 +275,7 @@
     }
     else
     {
-      sendto_one(source_p, form_str(ERR_NICKNAMEINUSE), me.name,
+      sendto_one(source_p, form_str(source_p,ERR_NICKNAMEINUSE), me.name,
                  parv[0], nick);
       return;
     }
@@ -308,13 +309,15 @@
  * server introducing new nick
  *    parv[0] = sender prefix
  *    parv[1] = nickname
- *    parv[2] = hop count
+ *    parv[2] = hop count (plus shifted svsflags when CAP_SVS-able)
  *    parv[3] = TS
  *    parv[4] = umode
  *    parv[5] = username
  *    parv[6] = hostname
  *    parv[7] = server
- *    parv[8] = ircname
+ *    parv[8] = real hostname (when CAP_HOSTMASK-able)
+ *    parv[9] = IP (when CAP_IP-able)
+ *    parv[10] = ircname
  */
 static void
 ms_nick(struct Client *client_p, struct Client *source_p,
@@ -323,16 +326,19 @@
   struct Client* target_p;
   char     nick[NICKLEN];
   time_t   newts = 0;
+  
+  cluster_prefix(client_p, parc, parv, 1, 0, 0);
 
   /* XXX BadPtr is needed */
   if(parc < 2 || BadPtr(parv[1]))
   {
-    sendto_one(source_p, form_str(ERR_NONICKNAMEGIVEN), me.name, parv[0]);
+    sendto_one(source_p, form_str(source_p,ERR_NONICKNAMEGIVEN), me.name, parv[0]);
     return;
   }
 
   /* parc == 3 on nickchange, parc == 9 on new nick */
-  if((IsClient(source_p) && (parc != 3)) || (IsServer(source_p) && (parc != 9)))
+  if((IsClient(source_p) && (parc != 3)) || 
+  	(IsServer(source_p) && ((parc < 9) || (parc > 11))))
   {
     char tbuf[BUFSIZE] = { 0 };
     int j;
@@ -359,18 +365,19 @@
   if(check_clean_nick(client_p, source_p, nick, parv[1], parv[7]))
     return;
 
-  if (parc == 9)
+  if (parc >= 9)
     {
       if (check_clean_user(client_p, nick, parv[5], parv[7]) ||
-          check_clean_host(client_p, nick, parv[6], parv[7]))
+          check_clean_host(client_p, nick, parv[6], parv[7]) || (parc > 9?
+          check_clean_host(client_p, nick, parv[8], parv[7]) : 0))
         return;
 
       /* check the length of the clients gecos */
-      if(strlen(parv[8]) > REALLEN)
+      if(strlen((parc > 9)? ((parc > 10)? parv[10] : parv[9]) : parv[8]) > REALLEN)
         {
           sendto_realops_flags(FLAGS_ALL, L_ALL, "Long realname from server %s for %s",
                          parv[7], parv[1]);
-          parv[8][REALLEN] = '\0';
+          parv[(parc > 9)? ((parc > 10)? 10 : 9) : 8][REALLEN] = '\0';
         }
 
       if (IsServer(source_p))
@@ -412,8 +419,6 @@
 
   perform_nick_collides(source_p, client_p, target_p,
                         parc, parv, newts, nick);
-			
-
 }
 
 /*
@@ -429,8 +434,10 @@
   char    *id;
   char    *name;
 
+  cluster_prefix(client_p, parc, parv, 1, 0, 0);
+
   id = parv[8];
-  name = parv[9];
+  name = (parc > 10)? ((parc > 11)? parv[11] : parv[10]) : parv[9];
 
   /* XXX can this happen ? */
   if (BadPtr(parv[1]))
@@ -442,7 +449,8 @@
   /* check the nicknames, usernames and hostnames are ok */
   if(check_clean_nick(client_p, source_p, nick, parv[1], parv[7]) ||
      check_clean_user(client_p, nick, parv[5], parv[7]) ||
-     check_clean_host(client_p, nick, parv[6], parv[7]))
+     check_clean_host(client_p, nick, parv[6], parv[7]) || (parc > 10?
+     check_clean_host(client_p, nick, parv[9], parv[7]) : 0))
     return;
 
   /* check length of clients gecos */
@@ -461,7 +469,7 @@
    */
   if((target_p = find_id(id)))
   {
-    sendto_realops_flags(FLAGS_ALL, L_ALL,
+    sendto_realops_flags(FLAGS_SKILL, L_ALL,
 		         "ID collision on %s(%s <- %s)(both killed)",
 			 target_p->name, target_p->from->name,
 			 client_p->name);
@@ -516,7 +524,7 @@
    * and dont bother messing at all
    */
 
-  if(!clean_nick_name(nick) || strcmp(nick, newnick))
+  if(!clean_nick_name(nick, 1) || strcmp(nick, newnick))
   {
     ServerStats->is_kill++;
     sendto_realops_flags(FLAGS_DEBUG, L_ALL,
@@ -602,7 +610,7 @@
     return 1;
   }
 
-  if(!clean_host_name(host))
+  if(!clean_host_name(host) && strcmp(host, "<none>"))
     sendto_realops_flags(FLAGS_DEBUG, L_ALL,
                          "Bad Hostname: %s Nickname: %s From: %s(via %s)",
 			 host, nick, server, client_p->name);
@@ -610,32 +618,65 @@
   return 0;
 }
 
-/* clean_nick_name()
+/*
+ * clean_nick_name - ensures that the given parameter (nick) is
+ * really a proper string for a nickname (note, the 'nick'
+ * may be modified in the process...)
  *
- * input	- nickname
- * output	- none
- * side effects - walks through the nickname, returning 0 if erroneous
+ *      RETURNS the length of the final NICKNAME (0, if
+ *      nickname is illegal)
+ *
+ *  Nickname characters are in range
+ *      'A'..'}', '_', '-', '0'..'9'
+ *  anything outside the above set will terminate nickname.
+ *  In addition, the first character cannot be '-'
+ *  or a Digit.
+ *
+ *  Note:
+ *      '~'-character should be NOT be allowed.
  */
 static int
-clean_nick_name(char *nick)
+clean_nick_name(char *nick, int fromserver)
 {
-  assert(nick);
-  if(nick == NULL)
-    return 0;
+  char* ch   = nick;
+  char* endp = ch + NICKLEN;
+  int cyr = 0, lat = 0;
 
-  /* nicks cant start with a digit or - or be 0 length */
-  /* This closer duplicates behaviour of hybrid-6 */
+  assert(0 != nick);
 
-  if (*nick == '-' || IsDigit(*nick) || *nick == '\0')
+  if (!fromserver)
+  if (*nick == '-' || IsDigit(*nick)) /* first character in [0..9-] */
     return 0;
 
-  for(; *nick; nick++)
-  {
-    if(!IsNickChar(*nick))
-      return 0;
-  }
+  for ( ; ch < endp && *ch; ++ch)
+    {
+      if (fromserver && (ch == nick))
+      	continue;
+      	
+      if (ConfigFileEntry.cyrillic && ((unsigned char)*ch >= 192))
+        {
+          if (lat)
+            break;      /* do not allow mixed lat/cyr nicks */
 
-  return 1;
+          cyr = 1;
+          continue;
+        }
+        
+      if (IsNickChar(*ch))
+        {
+          if (cyr && isalpha(*ch))
+            break;
+
+          if (isalpha(*ch))
+            lat = 1;
+          continue;
+        }
+
+      break;            /* invalid nick character */
+    }
+  *ch = '\0';
+
+  return (ch - nick);
 }
 
 /* clean_user_name()
@@ -689,6 +730,8 @@
 nick_from_server(struct Client *client_p, struct Client *source_p, int parc,
                  char *parv[], time_t newts,char *nick)
 {
+  int samenick = 0;
+  
   if(IsServer(source_p))
   {
     /* A server introducing a new client, change source */
@@ -700,7 +743,16 @@
       add_lazylinkclient(client_p, source_p);
 
     if(parc > 2)
-      source_p->hopcount = atoi(parv[2]);
+	{
+      if (IsCapable(client_p, CAP_SVS))
+      {
+        unsigned int val = atoi(parv[2]);
+
+        source_p->svsflags = val >> 8;
+        source_p->hopcount = val & 0xFF;       
+      } 
+        else source_p->hopcount = atoi(parv[2]);
+	}
     if(newts)
       source_p->tsinfo = newts;
     else
@@ -733,7 +785,8 @@
       }
 
       return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-                            parv[7], parv[8], NULL);
+			  parv[7], (parc > 9)? ((parc > 10)? parv[10] : parv[9]) : parv[8], 
+				(parc > 9)? parv[8] : NULL, (parc > 10)? parv[9] : NULL, NULL);
     }
   }
   else if(source_p->name[0])
@@ -756,15 +809,24 @@
   }
 
   /* set the new nick name */
-  if(source_p->name[0])
+  if (source_p->name[0]) {
     del_from_client_hash_table(source_p->name, source_p);
 
+	samenick = irccmp(source_p->name, nick) ? 0 : 1;
+	if (/*IsPerson(source_p) &&*/ !samenick)
+	  hash_check_watch(source_p, RPL_LOGOFF);
+  }
+
   strcpy(source_p->name, nick);
   add_to_client_hash_table(nick, source_p);
 
+  if (/*IsPerson(source_p) &&*/ !samenick)
+	hash_check_watch(source_p, RPL_LOGON);
+
   /* remove all accepts pointing to the client */
   del_all_accepts(source_p);
 
+  source_p->svsflags &= ~FLAGS_SVS_IDENT;
   return 0;
 }
 
@@ -782,7 +844,7 @@
   char *m;
 
   id = parv[8];
-  name = parv[9];
+  name = (parc > 10)? ((parc > 11)? parv[11] : parv[10]) : parv[9];
 
   source_p = make_client(client_p);
   add_client_to_list(source_p);
@@ -791,7 +853,15 @@
   if (ConfigFileEntry.hub && IsCapable(client_p, CAP_LL))
     add_lazylinkclient(client_p, source_p);
 
-  source_p->hopcount = atoi(parv[2]);
+  if (IsCapable(client_p, CAP_SVS))
+    {
+      unsigned int val = atoi(parv[2]);
+
+      source_p->svsflags = val >> 8;
+      source_p->hopcount = val & 0xFF;       
+    } 
+  else source_p->hopcount = atoi(parv[2]);
+
   source_p->tsinfo = newts;
 
   /* copy the nick in place */
@@ -811,11 +881,11 @@
 
     source_p->umodes |= flag & SEND_UMODES;
     m++;
-
   }
 
   return do_remote_user(nick, client_p, source_p, parv[5], parv[6],
-                        parv[7], name, id);
+			parv[7], name, (parc > 10)? parv[9] : NULL, 
+			(parc > 11)? parv[10] : NULL, id);
 }			
   
 static int 
@@ -832,7 +902,7 @@
     if(!newts || !target_p->tsinfo ||
        (newts == target_p->tsinfo))
     {
-      sendto_realops_flags(FLAGS_ALL, L_ALL,
+      sendto_realops_flags(FLAGS_SKILL, L_ALL,
                            "Nick collision on %s(%s <- %s)(both killed)",
 			   target_p->name, target_p->from->name,
 			   client_p->name);
@@ -844,7 +914,7 @@
                                  "%s (Nick collision (new))",
 				 me.name);
       ServerStats->is_kill++;
-      sendto_one(target_p, form_str(ERR_NICKCOLLISION),
+      sendto_one(target_p, form_str(target_p,ERR_NICKCOLLISION),
                  me.name, target_p->name, target_p->name);
 
       target_p->flags |= FLAGS_KILLED;
@@ -870,18 +940,18 @@
       else
       {
         if(sameuser)
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
+	  sendto_realops_flags(FLAGS_SKILL, L_ALL,
 	                  "Nick collision on %s(%s <- %s)(older killed)",
 			  target_p->name, target_p->from->name,
 			  client_p->name);
         else
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
+	  sendto_realops_flags(FLAGS_SKILL, L_ALL,
 	                  "Nick collision on %s(%s <- %s)(newer killed)",
 			  target_p->name, target_p->from->name,
 			  client_p->name);
 
         ServerStats->is_kill++;
-	sendto_one(target_p, form_str(ERR_NICKCOLLISION),
+	sendto_one(target_p, form_str(target_p,ERR_NICKCOLLISION),
 	           me.name, target_p->name, target_p->name);
 
         /* if it came from a LL server, itd have been source_p,
@@ -908,13 +978,13 @@
   if(!newts || !target_p->tsinfo || (newts == target_p->tsinfo) ||
        !source_p->user)
     {
-      sendto_realops_flags(FLAGS_ALL, L_ALL,
+      sendto_realops_flags(FLAGS_SKILL, L_ALL,
                  "Nick change collision from %s to %s(%s <- %s)(both killed)",
 		 source_p->name, target_p->name, target_p->from->name,
 		 client_p->name);
     
       ServerStats->is_kill++;
-      sendto_one(target_p, form_str(ERR_NICKCOLLISION),
+      sendto_one(target_p, form_str(target_p,ERR_NICKCOLLISION),
                  me.name, target_p->name, target_p->name);
 
       /* if we got the message from a LL, it knows about source_p */
@@ -946,12 +1016,12 @@
           (!sameuser && newts > target_p->tsinfo))
       {
         if(sameuser)
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
+	  sendto_realops_flags(FLAGS_SKILL, L_ALL,
  	       "Nick change collision from %s to %s(%s <- %s)(older killed)",
 	       source_p->name, target_p->name, target_p->from->name,
 	       client_p->name);
         else
-	  sendto_realops_flags(FLAGS_ALL, L_ALL,
+	  sendto_realops_flags(FLAGS_SKILL, L_ALL,
 	       "Nick change collision from %s to %s(%s <- %s)(newer killed)",
 	       source_p->name, target_p->name, target_p->from->name,
 	       client_p->name);
@@ -974,12 +1044,12 @@
      else
      {
        if(sameuser)
-         sendto_realops_flags(FLAGS_ALL, L_ALL,
+         sendto_realops_flags(FLAGS_SKILL, L_ALL,
 	                      "Nick collision on %s(%s <- %s)(older killed)",
 			      target_p->name, target_p->from->name,
 			      client_p->name);
        else
-         sendto_realops_flags(FLAGS_ALL, L_ALL,
+         sendto_realops_flags(FLAGS_SKILL, L_ALL,
 	                      "Nick collision on %s(%s <- %s)(newer killed)",
 			      target_p->name, target_p->from->name,
 			      client_p->name);
@@ -989,7 +1059,7 @@
 				 me.name);
 
        ServerStats->is_kill++;
-       sendto_one(target_p, form_str(ERR_NICKCOLLISION),
+       sendto_one(target_p, form_str(target_p,ERR_NICKCOLLISION),
                   me.name, target_p->name, target_p->name);
 
        target_p->flags |= FLAGS_KILLED;
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_part.c ircd-hybrid-7-bg/modules/core/m_part.c
--- ircd-hybrid-7rc5/modules/core/m_part.c	Fri May 24 19:34:39 2002
+++ ircd-hybrid-7-bg/modules/core/m_part.c	Sat May 24 23:27:10 2003
@@ -19,13 +19,14 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_part.c,v 1.56 2002/05/24 23:34:39 androsyn Exp $
+ *  $Id: m_part.c,v 1.5 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
 #include "tools.h"
 #include "handlers.h"
 #include "channel.h"
+#include "channel_mode.h"
 #include "vchannel.h"
 #include "client.h"
 #include "common.h"  
@@ -41,6 +42,7 @@
 #include "modules.h"
 #include "s_conf.h"
 #include "packet.h"
+#include "s_misc.h"
 
 static void m_part(struct Client*, struct Client*, int, char**);
 void check_spambot_warning(struct Client *source_p, const char *name);
@@ -62,7 +64,7 @@
 {
   mod_del_cmd(&part_msgtab);
 }
-const char *_version = "$Revision: 1.56 $";
+const char *_version = "$Revision: 1.5 $";
 #endif
 
 static void part_one_client(struct Client *client_p,
@@ -83,10 +85,13 @@
 {
   char  *p, *name;
   char reason[TOPICLEN+1];
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  cluster_prefix(client_p, parc, parv, 1, 1, 0);
 
   if (*parv[1] == '\0')
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "PART");
       return;
     }
@@ -129,7 +134,7 @@
 
   if ((chptr = hash_find_channel(name)) == NULL)
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHCHANNEL),
 		 me.name, source_p->name, name);
       return;
     }
@@ -155,7 +160,7 @@
 
   if (!chptr || !bchan || !IsMember(source_p, chptr))
     {
-      sendto_one(source_p, form_str(ERR_NOTONCHANNEL),
+      sendto_one(source_p, form_str(source_p,ERR_NOTONCHANNEL),
                  me.name, source_p->name, name);
       return;
     }
@@ -171,13 +176,22 @@
       (source_p->firsttime + ConfigFileEntry.anti_spam_exit_message_time)
       < CurrentTime))))
     {
+      /*strip_color(reason);*/
+      reason = strip_color(reason, 1);
+
+	  if (match("*http://*", reason) || match("*www*", reason))
+		reason = "<spam removed>";
+
       sendto_server(client_p, NULL, chptr, CAP_UID, NOCAPS, NOFLAGS,
                     ":%s PART %s :%s", ID(source_p), chptr->chname,
                     reason);
       sendto_server(client_p, NULL, chptr, NOCAPS, CAP_UID, NOFLAGS,
-                    ":%s PART %s  :%s", source_p->name, chptr->chname,
+                    ":%s PART %s :%s", source_p->name, chptr->chname,
                     reason);
-      sendto_channel_local(ALL_MEMBERS,
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+		add_pace(chptr, source_p, bchan->chname, 0, 0);
+      else
+      	sendto_channel_local(ALL_MEMBERS,
                            chptr, ":%s!%s@%s PART %s :%s",
                            source_p->name,
                            source_p->username,
@@ -191,12 +205,19 @@
                     ":%s PART %s", ID(source_p), chptr->chname);
       sendto_server(client_p, NULL, chptr, NOCAPS, CAP_UID, NOFLAGS,
                     ":%s PART %s", source_p->name, chptr->chname);
-      sendto_channel_local(ALL_MEMBERS,
+      if (PaceChannel(chptr) && (chptr->parts < MAX_PACEJOIN))
+		add_pace(chptr, source_p, bchan->chname, 0, 0);
+      else
+      	sendto_channel_local(ALL_MEMBERS,
                            chptr, ":%s!%s@%s PART %s",
                            source_p->name,
                            source_p->username,
                            source_p->host,
                            bchan->chname);
     }
+
   remove_user_from_channel(chptr, source_p);
+
+  if (MyConnect(source_p))
+	source_p->localClient->last_leave_time = CurrentTime;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_quit.c ircd-hybrid-7-bg/modules/core/m_quit.c
--- ircd-hybrid-7rc5/modules/core/m_quit.c	Thu Jul 11 21:01:22 2002
+++ ircd-hybrid-7-bg/modules/core/m_quit.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_quit.c,v 1.26 2002/07/12 01:01:22 androsyn Exp $
+ *  $Id: m_quit.c,v 1.4 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -33,6 +33,7 @@
 #include "parse.h"
 #include "modules.h"
 #include "s_conf.h"
+#include "s_misc.h"
 
 static void m_quit(struct Client*, struct Client*, int, char**);
 static void ms_quit(struct Client*, struct Client*, int, char**);
@@ -55,7 +56,7 @@
   mod_del_cmd(&quit_msgtab);
 }
 
-const char *_version = "$Revision: 1.26 $";
+const char *_version = "$Revision: 1.4 $";
 #endif
 /*
 ** m_quit
@@ -67,13 +68,18 @@
                   int parc,
                   char *parv[])
 {
+  static char *dummy = "<no reason>";
   char *comment = (parc > 1 && parv[1]) ? parv[1] : client_p->name;
   char reason [TOPICLEN + 1];
+  if (!comment[0]) comment = dummy;
 
   source_p->flags |= FLAGS_NORMALEX;
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
 
+  if (match("*http://*", comment) || match("*www*", comment))
+	  comment = "<spam removed>";
+
   if (ConfigFileEntry.client_exit && comment[0])
     {
 #ifndef VMS
@@ -91,6 +97,10 @@
       comment = "Client Quit";
     }
 
+  if (parc > 1)
+    /*strip_color(comment);*/
+    comment = strip_color(comment, 1);
+
   exit_client(client_p, source_p, source_p, comment);
 }
 
@@ -104,12 +114,20 @@
                    int parc,
                    char *parv[])
 {
-  char *comment = (parc > 1 && parv[1]) ? parv[1] : client_p->name;
+  static char *dummy = "<no reason>";
+  char *comment;
+  
+  cluster_prefix(client_p, parc, parv, 0, 0, 0);
+  comment = (parc > 1 && parv[1]) ? parv[1] : client_p->name;
+  if (!comment[0]) comment = dummy;
 
   source_p->flags |= FLAGS_NORMALEX;
   if (strlen(comment) > (size_t) TOPICLEN)
     comment[TOPICLEN] = '\0';
 
+  if (parc > 1)
+    /*strip_color(comment);*/
+    comment = strip_color(comment, 1);
+
   exit_client(client_p, source_p, source_p, comment);
 }
-
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_server.c ircd-hybrid-7-bg/modules/core/m_server.c
--- ircd-hybrid-7rc5/modules/core/m_server.c	Wed Oct  9 12:59:49 2002
+++ ircd-hybrid-7-bg/modules/core/m_server.c	Mon Dec 30 23:08:14 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_server.c,v 1.89 2002/10/09 16:59:49 androsyn Exp $
+ *  $Id: m_server.c,v 1.1.1.1 2002/12/31 04:08:14 demond Exp $
  */
 
 #include "stdinc.h"
@@ -67,7 +67,7 @@
 {
   mod_del_cmd(&server_msgtab);
 }
-const char *_version = "$Revision: 1.89 $";
+const char *_version = "$Revision: 1.1.1.1 $";
 #endif
 
 int bogus_host(char *host);
@@ -457,8 +457,6 @@
       return;
     }
   
-
-
   if(strlen(name) > HOSTLEN)
   {
     sendto_realops_flags(FLAGS_ALL, L_ADMIN,
@@ -523,11 +521,11 @@
 		 target_p->hidden_server ? "(H) " : "",
 		 target_p->info);
     }
-      
-  sendto_realops_flags(FLAGS_EXTERNAL, L_ALL,
+    
+  if (!IsRelay(target_p))  
+  	sendto_realops_flags(FLAGS_EXTERNAL, L_ALL,
                        "Server %s being introduced by %s",
-		       target_p->name, source_p->name);
-
+		       			target_p->name, source_p->name);
 }
 
 /* set_server_gecos()
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_sjoin.c ircd-hybrid-7-bg/modules/core/m_sjoin.c
--- ircd-hybrid-7rc5/modules/core/m_sjoin.c	Thu Jul  4 12:07:23 2002
+++ ircd-hybrid-7-bg/modules/core/m_sjoin.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_sjoin.c,v 1.140 2002/07/04 16:07:23 androsyn Exp $
+ *  $Id: m_sjoin.c,v 1.3 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -41,6 +41,7 @@
 #include "modules.h"
 #include "s_serv.h"
 #include "s_conf.h"
+#include "s_misc.h"
 
 
 static void ms_sjoin(struct Client*, struct Client*, int, char**);
@@ -63,7 +64,7 @@
   mod_del_cmd(&sjoin_msgtab);
 }
 
-const char *_version = "$Revision: 1.140 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 /*
  * ms_sjoin
@@ -139,6 +140,10 @@
   if (IsClient(source_p) || parc < 5)
     return;
   
+  cluster_prefix(client_p, parc, parv, 2, 1, 0);
+  cluster_prefix(client_p, parc, parv, parc - 1, 0, 1);
+  
+  if (!ServerInfo.gateway || !get_bridge_token(client_p))
   if (!IsChannelName(parv[2]))
     return;
   if (!check_channel_name(parv[2]))
@@ -184,6 +189,30 @@
           mode.mode |= MODE_HIDEOPS;
         break;
 #endif
+      case 'c':
+        mode.mode |= MODE_NOCOLOR;
+        break;
+      case 'r':
+        mode.mode |= MODE_REGCHAN;
+        break;
+      case 'x':
+        mode.mode |= MODE_PACE;
+        break;
+      case 'z':
+        mode.mode |= MODE_NOREPEAT;
+        break;
+      case 'R':
+        mode.mode |= MODE_REGNICKS;
+        break;
+      case 'C':
+        mode.mode |= MODE_CYRNICKS;
+        break;
+      case 'M':
+        mode.mode |= MODE_REGSPEAK;
+        break;
+      case 'S':
+        mode.mode |= MODE_SSLONLY;
+        break;
       case 'k':
         strlcpy(mode.key, parv[4 + args], KEYLEN);
         args++;
@@ -498,7 +527,7 @@
       if (!(target_p = find_client(s)) ||
          (target_p->from != client_p) || !IsPerson(target_p))
       {
-        sendto_one(source_p, form_str(ERR_NOSUCHNICK), me.name,
+        sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK), me.name,
 	           source_p->name, s);
 
 #ifdef HALFOPS
@@ -576,7 +605,11 @@
 	  if (top_chptr)
 	    {
 	      add_vchan_to_client_cache(target_p,top_chptr, chptr);
-	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
+
+          if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+	        add_pace(chptr, target_p, top_chptr->chname, 1, 0);
+	      else
+	      	sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
 				   target_p->host,
@@ -585,7 +618,10 @@
 	  else
 #endif
 	    {
-	      sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
+          if (PaceChannel(chptr) && (chptr->joins < MAX_PACEJOIN))
+	        add_pace(chptr, target_p, parv[2], 1, 0);
+	      else
+	      	sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s JOIN :%s",
 				   target_p->name,
 				   target_p->username,
 				   target_p->host,
@@ -740,6 +776,14 @@
 #ifdef ANONOPS
   { MODE_HIDEOPS,    'a' },
 #endif
+  { MODE_NOCOLOR,    'c' },
+  { MODE_REGCHAN,    'r' },
+  { MODE_PACE,       'x' },
+  { MODE_NOREPEAT,   'z' },
+  { MODE_REGNICKS,   'R' },
+  { MODE_REGSPEAK,   'M' },
+  { MODE_CYRNICKS,   'C' },
+  { MODE_SSLONLY,    'S' },
   { 0, 0 }
 };
 
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/core/m_squit.c ircd-hybrid-7-bg/modules/core/m_squit.c
--- ircd-hybrid-7rc5/modules/core/m_squit.c	Fri May 24 19:34:39 2002
+++ ircd-hybrid-7-bg/modules/core/m_squit.c	Sat May 24 23:27:10 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_squit.c,v 1.45 2002/05/24 23:34:39 androsyn Exp $
+ *  $Id: m_squit.c,v 1.3 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -36,6 +36,7 @@
 #include "msg.h"
 #include "parse.h"
 #include "modules.h"
+#include "s_misc.h"
 
 
 static void ms_squit(struct Client*, struct Client*, int, char**);
@@ -58,7 +59,7 @@
 {
   mod_del_cmd(&squit_msgtab);
 }
-const char *_version = "$Revision: 1.45 $";
+const char *_version = "$Revision: 1.3 $";
 #endif
 struct squit_parms 
 {
@@ -91,7 +92,7 @@
 
   if(parc < 2)
     {
-      sendto_one(source_p, form_str(ERR_NEEDMOREPARAMS),
+      sendto_one(source_p, form_str(source_p,ERR_NEEDMOREPARAMS),
                  me.name, parv[0], "SQUIT");
       return;
     }
@@ -113,7 +114,7 @@
     }
   else
     {
-	    sendto_one(source_p, form_str(ERR_NOSUCHSERVER),
+	    sendto_one(source_p, form_str(source_p,ERR_NOSUCHSERVER),
 		       me.name, parv[0], parv[1]);
     }
 }
@@ -129,6 +130,12 @@
 {
   struct squit_parms *found_squit;
   char  *comment = (parc > 2 && parv[2]) ? parv[2] : client_p->name;
+  
+  if (ServerInfo.gateway && get_bridge_token(client_p)) {
+  
+  	if (!IsServer(source_p))
+  		return;
+  }
 
   if(parc < 2)
     {
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/descrip.mms ircd-hybrid-7-bg/modules/descrip.mms
--- ircd-hybrid-7rc5/modules/descrip.mms	Thu May 23 18:20:12 2002
+++ ircd-hybrid-7-bg/modules/descrip.mms	Mon Dec 30 23:07:25 2002
@@ -1,6 +1,6 @@
 # MMS/MMK Makefile for OpenVMS
 # Copyright (c) 2001 Edward Brocklesby
-# $Id: descrip.mms,v 1.6 2002/05/23 22:20:12 leeh Exp $
+# $Id: descrip.mms,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
 
 CC=	CC
 CFLAGS=	/INCLUDE_DIRECTORY=([-.INCLUDE],[-.ADNS])/STANDARD=ISOC94
diff -uNrd -x CVS ircd-hybrid-7rc5/modules/m_accept.c ircd-hybrid-7-bg/modules/m_accept.c
--- ircd-hybrid-7rc5/modules/m_accept.c	Thu Sep  5 02:05:40 2002
+++ ircd-hybrid-7-bg/modules/m_accept.c	Mon Mar 10 01:09:00 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_accept.c,v 1.33 2002/09/05 06:05:40 db Exp $
+ *  $Id: m_accept.c,v 1.2 2003/03/10 06:09:00 demond Exp $
  */
 
 #include "stdinc.h"
@@ -60,7 +60,7 @@
   mod_del_cmd(&accept_msgtab);
 }
 
-const char *_version = "$Revision: 1.33 $";
+const char *_version = "$Revision: 1.2 $";
 #endif
 /*
  * m_accept - ACCEPT command handler
@@ -92,7 +92,7 @@
     /* shouldnt happen, but lets be paranoid */
     if(((target_p = find_client(nick)) == NULL) || !IsPerson(target_p))
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),
                  me.name, source_p->name, nick);
       continue;
     }
@@ -100,7 +100,7 @@
     /* user isnt on clients accept list */
     if(!accept_message(target_p, source_p))
     {
-      sendto_one(source_p, form_str(ERR_ACCEPTNOT),
+      sendto_one(source_p, form_str(source_p,ERR_ACCEPTNOT),
                  me.name, source_p->name, target_p->name);
       continue;
     }
@@ -118,7 +118,7 @@
     /* shouldnt happen, but lets be paranoid */
     if(((target_p = find_client(nick)) == NULL) || !IsPerson(target_p)) 
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),
                  me.name, source_p->name, nick);
       continue;
     }
@@ -126,14 +126,14 @@
     /* user is already on clients accept list */
     if(accept_message(target_p, source_p))
     {
-      sendto_one(source_p, form_str(ERR_ACCEPTEXIST),
+      sendto_one(source_p, form_str(source_p,ERR_ACCEPTEXIST),
                  me.name, source_p->name, target_p->name);
       continue;
     }
 
     if(accept_num >= ConfigFileEntry.max_accept)
     {
-      sendto_one(source_p, form_str(ERR_ACCEPTFULL),
+      sendto_one(source_p, form_str(source_p,ERR_ACCEPTFULL),
                  me.name, source_p->name);
       return;
     }
@@ -181,7 +181,7 @@
 
     if(((target_p = find_client(name)) == NULL) || !IsPerson(target_p))
     {
-      sendto_one(source_p, form_str(ERR_NOSUCHNICK),
+      sendto_one(source_p, form_str(source_p,ERR_NOSUCHNICK),
                  me.name, source_p->name, name);
       continue;
     }
@@ -256,7 +256,7 @@
 
       if((len + strlen(target_p->name) + len2 > BUFSIZE) || count > 14)
       {
-        sendto_one(source_p, form_str(RPL_ACCEPTLIST),
+        sendto_one(source_p, form_str(source_p,RPL_ACCEPTLIST),
 	           me.name, source_p->name, nicks);
 		   
 	len = count = 0;
@@ -271,10 +271,10 @@
   }
 
   if(*nicks)
-    sendto_one(source_p, form_str(RPL_ACCEPTLIST),
+    sendto_one(source_p, form_str(source_p,RPL_ACCEPTLIST),
                me.name, source_p->name, nicks);
 
-  sendto_one(source_p, form_str(RPL_ENDOFACCEPT),
+  sendto_one(source_p, form_str(source_p,RPL_ENDOFACCEPT),
              me.name, source_p->name);
 
 }
